from machine import Pin
from time import sleep
from logging import fatal, info

dit = 0.1
dah = dit * 3
intra_char = dit
inter_char = dah
inter_word = dit * 7
codes = {'S': '...', 'O': '---'}

def morse(msg):
    for word in msg.split():
        sleep(inter_word)
        for char in word.upper():
            sleep(inter_char)
            for bit in codes[char]:
                sleep(intra_char)
                led.on()
                if bit == '.':
                    sleep(dit)
                elif bit == '-':
                    sleep(dah)
                else:
                    assert False, 'invalid morse char!'
                led.off()

led = Pin('LED', Pin.OUT)
morse('SOS')
morse('PICO')
